import * as React from 'react';
export interface Props extends React.Props<StickyContainer> {
    className?: string;
    contentClassName?: string;
    stickyClassName?: string;
    stickyTransitionClassName?: string;
    style?: React.CSSProperties;
    contentStyle?: React.CSSProperties;
}
export interface State {
    ref: string;
    top: number;
    height: number;
    width: number;
}
export default class StickyContainer extends React.Component<Props, State> {
    refs: {
        [k: string]: React.ReactInstance;
        container: HTMLDivElement;
    };
    constructor(props: Props);
    render(): JSX.Element;
    refresh(): void;
    scrollToTop(): void;
    currentStickyElementIdentifier(): string;
    private onScrollHandler;
    private stickyHeaderHandler;
    private getContainerTopPosition();
    private getCover;
    private getSticky;
    private getChildren;
}
