"use strict";

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var React = require('react');
var ReactDOM = require('react-dom');
var element_1 = require('./element');
var scheduled = false;

var StickyContainer = function (_React$Component) {
    _inherits(StickyContainer, _React$Component);

    function StickyContainer(props) {
        _classCallCheck(this, StickyContainer);

        var _this = _possibleConstructorReturn(this, (StickyContainer.__proto__ || Object.getPrototypeOf(StickyContainer)).call(this, props));

        _this.onScrollHandler = function () {
            if (scheduled) {
                return;
            }
            scheduled = true;
            window.requestAnimationFrame(function () {
                _this.stickyHeaderHandler();
                scheduled = false;
            });
        };
        _this.stickyHeaderHandler = function () {
            var container = _this.refs.container;
            var state = {
                ref: null,
                top: null,
                height: 0,
                width: 0
            };
            if (container.scrollTop === 0) {
                _this.setState(state);
                return;
            }
            var sticky = _this.state.ref ? ReactDOM.findDOMNode(_this.refs[_this.state.ref]) : null;
            var node = {
                ref: _this.state.ref,
                top: sticky ? sticky.offsetTop : null,
                height: sticky ? sticky.getBoundingClientRect().height : 0,
                width: sticky ? sticky.getBoundingClientRect().width : 0
            };
            if (sticky && sticky.offsetTop >= container.scrollTop) {
                node = state;
            }
            Object.keys(_this.refs).filter(function (ref) {
                return ref.startsWith('sticky_');
            }).forEach(function (ref) {
                var element = ReactDOM.findDOMNode(_this.refs[ref]);
                var offsetTop = element.offsetTop;
                if (container.scrollTop + 2 >= offsetTop) {
                    if (node && node.top && node.top >= offsetTop) return;
                    node = {
                        ref: ref,
                        top: offsetTop - element.offsetHeight,
                        height: element.getBoundingClientRect().height,
                        width: element.getBoundingClientRect().width
                    };
                    sticky = element;
                } else if (sticky) {
                    if (container.scrollTop + sticky.offsetHeight >= offsetTop) {
                        state.top = offsetTop - sticky.offsetHeight;
                    }
                }
            });
            if (node && node.ref) {
                if (node.ref === _this.state.ref && state.top === _this.state.top) return;
                state.ref = node.ref;
                state.height = node.height;
                state.width = node.width;
            }
            _this.setState(state);
        };
        _this.getCover = function () {
            if (!_this.state.ref) return null;
            var style = {
                width: _this.state.width + 'px',
                height: _this.state.height + 'px',
                position: 'fixed',
                top: _this.getContainerTopPosition(),
                background: 'white',
                zIndex: 10
            };
            return React.createElement("div", { style: style });
        };
        _this.getSticky = function () {
            if (!_this.state.ref) return null;
            var inTransition = _this.state.top !== null;
            var sticky = _this.refs[_this.state.ref];
            if (!sticky) {
                return null;
            }
            var style = _extends({}, {
                width: _this.state.width + 'px',
                height: _this.state.height + 'px',
                position: inTransition ? 'absolute' : 'fixed',
                top: inTransition ? _this.state.top : _this.getContainerTopPosition(),
                zIndex: 20
            });
            var className = inTransition ? _this.props.stickyTransitionClassName : _this.props.stickyClassName;
            return React.createElement("div", { className: className, style: style }, React.createElement(element_1.default, _extends({}, sticky.props, {
                style: _extends({}, sticky.props.style || {}, {
                    visibility: 'visible'
                })
            })));
        };
        _this.getChildren = function () {
            return React.Children.map(_this.props.children, function (child, idx) {
                if (child.type === element_1.default) {
                    return React.cloneElement(child, {
                        ref: 'sticky_' + idx,
                        style: {
                            position: 'relative',
                            visibility: _this.state.ref === 'sticky_' + idx ? 'hidden' : 'visible',
                            zIndex: _this.state.ref === 'sticky_' + idx ? 5 : 15
                        }
                    });
                }
                return child;
            });
        };
        _this.state = {
            ref: null,
            top: 0,
            height: 0,
            width: 0
        };
        return _this;
    }

    _createClass(StickyContainer, [{
        key: 'render',
        value: function render() {
            var style = _extends({}, this.props.style, { overflowY: 'auto', position: 'relative', zIndex: 100 });
            var contentStyle = _extends({}, this.props.contentStyle, { position: 'relative' });
            return React.createElement("div", { ref: "container", style: style, onScroll: this.onScrollHandler, className: this.props.className }, React.createElement("div", { className: this.props.contentClassName, style: contentStyle }, this.getCover(), this.getSticky(), this.getChildren()));
        }
    }, {
        key: 'refresh',
        value: function refresh() {
            this.onScrollHandler();
        }
    }, {
        key: 'scrollToTop',
        value: function scrollToTop() {
            this.refs.container.scrollTop = 0;
        }
    }, {
        key: 'currentStickyElementIdentifier',
        value: function currentStickyElementIdentifier() {
            var currentStickyElement = this.refs[this.state.ref];
            if (!currentStickyElement) {
                return;
            }
            return currentStickyElement.props.identifier;
        }
    }, {
        key: 'getContainerTopPosition',
        value: function getContainerTopPosition() {
            return this.refs.container.getBoundingClientRect().top;
        }
    }]);

    return StickyContainer;
}(React.Component);

Object.defineProperty(exports, "__esModule", { value: true });
exports.default = StickyContainer;